% This script performs trivial linear interpolation on the results of the
% transfer matrix program to make the data usable in the set of ODEs. The
% input variable l is the position (m).
function gen = Gopt(l)

global genp
global dev_l

if l <= 0.5e-9,
    mb = inv([0.5e-9 1; 1.5e-9 1])*[genp(1); genp(2)];
    gen = (mb(1)*l+mb(2))*1e6;
end

if l >= (dev_l-(0.5e-9)),
    mb = inv([dev_l-(1.5e-9) 1; dev_l-(0.5e-9) 1])*[genp(length(genp)-1); genp(length(genp))];
    gen = (mb(1)*l+mb(2))*1e6;
end

if (l > 0.5e-9)&&(l < (dev_l-(0.5e-9))),
    k = 1;
    for i = 0.5e-9:1e-9:(dev_l-0.5e-9),
        if (l-i)>0,
            ind_l = k;
            pos_l = i;
            ind_r = k+1;
            pos_r = i+1;
        end
        k = k+1;
    end
    mb = inv([pos_l 1; pos_r 1])*[genp(ind_l); genp(ind_r)];
    gen = (mb(1)*l+mb(2))*1e6;
end