% Computes derivative of the electric field. Input variable x is the
% acceptor/[acceptor+donor] composition.
function der = efieldder(x)

global E
global avgperm

der = ((avgperm/perm(x+1e-3))*E-(avgperm/perm(x))*E)/(1e-3);